Attribute VB_Name = "ModDeclares"
Option Explicit

Public Const MAX_PATH As Long = 260
Public Const FORW_SLASH As String = "/"
Public Const BACK_SLASH As String = "\"
Public Const LETTER_S As String = "s"
Public Const QUOTEMARK$ = """"
Public Const sSETUP As String = "Blah Program Setup"   '--UNIQUE  (title used for message boxes in setup.)
Public Const sCOLON As String = ":"
Public Const cDOT As String = "."
Public Const cATSIGN As String = "@"
Public Const sCOMMA = ","
Public Const GstrASSIGN$ = "="
Public Const GsEXT_FONTTTF As String = "TTF"
Public Const GsEXT_FONTFON As String = "FON"
Public Const GsREGEDIT As String = "regedit /s "
Public Const GsEXT_REG As String = "reg"

'Return values for setup toolkit functions
Public Const GintRET_CONT% = 1
Public Const GintRET_CANCEL% = 2
Public Const GintRET_EXIT% = 3
Public Const GintRET_ABORT% = 4
Public Const GintRET_FATAL% = 5
'-- Public Const GintRET_NORUNTIMES% = 7
Public Const GintRET_FINISHEDSUCCESS% = 6 'Used only as parameter to ExitSetup at end of successful install

Public Const GintNOVERINFO% = 32767

Public Const intDRIVE_REMOVABLE% = 2                    'Constants for GetDriveType
Public Const intDRIVE_FIXED% = 3
Public Const intDRIVE_REMOTE% = 4
Public Const intDRIVE_CDROM% = 5

'setup information file registration macros
'These should remain uppercase
Public Const MstrDLLSELFREGISTER$ = "$(DLLSELFREGISTER)"
Public Const MstrEXESELFREGISTER$ = "$(EXESELFREGISTER)"
Public Const MstrTLBREGISTER$ = "$(TLBREGISTER)"
Public Const MstrREMOTEREGISTER$ = "$(REMOTE)"
Public Const MstrVBLREGISTER$ = "$(VBLREGISTER)"

'Global Action Key constants
Public Const GstrKEY_PRIVATEFILE = "PrivateFile"
Public Const GstrKEY_TEMPFILE = "TempFile"
Public Const GstrKEY_SHAREDFILE = "SharedFile"
Public Const GstrKEY_SYSTEMFILE = "SystemFile"
Public Const GstrKEY_CREATEDIR = "CreateDir"
Public Const GstrKEY_SHELLLINK = "ShellLink"
Public Const GstrKEY_DLLSELFREGISTER = "DllSelfRegister"
Public Const GstrKEY_EXESELFREGISTER = "ExeSelfRegister"
Public Const GstrKEY_TLBREGISTER = "TLBRegister"
Public Const GstrKEY_REMOTEREGISTER = "RemoteRegister"
Public Const GstrKEY_REGKEY = "RegKey"
Public Const GstrKEY_REGVALUE = "RegValue"

'Error levels for GetAppRemovalCmdLine()
Public Const APPREMERR_NONE = 0 'no error
Public Const APPREMERR_FATAL = 1 'fatal error
Public Const APPREMERR_NONFATAL = 2 'non-fatal error, user chose to abort
Public Const APPREMERR_USERCANCEL = 3 'user chose to cancel (no error)

Public Const MstrPRIVATEFILE = vbNullString
Public Const MstrSHAREDFILE = "$(Shared)"

'Setup information file macros
Public Const GstrAPPDEST$ = "$(AppPath)"
Public Const GstrWINDEST$ = "$(WinPath)"
Public Const GstrFONTDEST$ = "$(Font)"
Public Const GstrWINSYSDEST$ = "$(WinSysPath)"
Public Const GstrWINSYSDESTSYSFILE$ = "$(WinSysPathSysFile)"
Public Const GstrPROGRAMFILES$ = "$(ProgramFiles)"
Public Const GstrCOMMONFILES$ = "$(CommonFiles)"
Public Const GstrCOMMONFILESSYS$ = "$(CommonFilesSys)"
Public Const GstrDAODEST$ = "$(MSDAOPath)"
Public Const GstrAPPDATA$ = "$(AppData)"  '-- new for this version of setup1.


'Shell Constants
Public Const NORMAL_PRIORITY_CLASS      As Long = &H20&
Public Const INFINITE                   As Long = -1&
Public Const STATUS_WAIT_0              As Long = &H0
Public Const WAIT_OBJECT_0              As Long = STATUS_WAIT_0

Public Const GENERIC_WRITE As Long = &H40000000
Public Const GENERIC_READ As Long = &H80000000
Public Const FILE_ATTRIBUTE_NORMAL As Long = &H80
Public Const FILE_FLAG_WRITE_THROUGH As Long = &H80000000
Public Const OPEN_EXISTING As Long = 3
Public Const INVALID_HANDLE_VALUE As Long = -1
Public Const ERROR_SHARING_VIOLATION As Long = 32

'--borderizing constants:
Public Const SWP_FRAMECHANGED = &H20
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOZORDER = &H4
Public Const SWP_NOSIZE = &H1
Public Const swpFlags As Long = SWP_FRAMECHANGED Or SWP_NOMOVE Or SWP_NOZORDER Or SWP_NOSIZE
Public Const WS_EX_DLGMODALFRAME = &H1&   '3D Raised style
Public Const WS_EX_WINDOWEDGE = &H100     '3D border
Public Const WS_EX_CLIENTEDGE = &H200     '3D sunken style
Public Const WINDOW_FRAME_1 = &H301
Public Const WINDOW_FRAME_2 = &H101
Public Const GWL_EXSTYLE = (-20)

'---------ENUMS -----------------------------------

'Public Enum OverwriteReturnVal
  '  owYes
   ' owNo
   ' owNoToAll
'End Enum


'--------- TYPES ------------------------------------

Public Type DESTINFO                                        ' save dest dir for certain files
    strAppDir As String
    strAUTMGR32 As String
    strRACMGR32 As String
End Type

Public Type VERINFO                                            'Version FIXEDFILEINFO
    'There is data in the following two dwords, but it is for Windows internal
    '   use and we should ignore it
    Ignore(1 To 8) As Byte
    'Signature As Long
    'StrucVersion As Long
    FileVerPart2 As Integer
    FileVerPart1 As Integer
    FileVerPart4 As Integer
    FileVerPart3 As Integer
    ProductVerPart2 As Integer
    ProductVerPart1 As Integer
    ProductVerPart4 As Integer
    ProductVerPart3 As Integer
    FileFlagsMask As Long 'VersionFileFlags
    FileFlags As Long 'VersionFileFlags
    FileOS As Long 'VersionOperatingSystemTypes
    FileType As Long
    FileSubtype As Long 'VersionFileSubTypes
    'I've never seen any data in the following two dwords, so I'll ignore them
    Ignored(1 To 8) As Byte 'DateHighPart As Long, DateLowPart As Long
End Type

Public Type FILEINFO                    ' Setup information file line format
  intDiskNum As Integer                ' disk number
  fDestDirRecognizedBySetupExe As Boolean  ' Does setup.exe recognize this destination directory macro?
  strSrcName As String                     ' name of source file
  strDestName As String                    ' name of destination file
  strDestDir As String                     ' destination directory
  strRegister As String                    ' registration info
  fShared As Boolean                     ' whether the file is shared or private
  fSystem As Boolean               ' whether the file is a system file (i.e. should be installed but never removed)
  varDate As Date                         ' file date
  lFileSize As Long                      ' file size
  sVerInfo As VERINFO                    ' file version number
  strReserved As String                     ' Reserved. Leave empty, or error.
  strProgramIconTitle As String               ' Caption for icon in program group
  strProgramIconCmdLine As String          ' Command Line for icon in program group
End Type

Public Type REGINFO                                         ' save registration info for files
    strFilename As String
    strRegister As String
    
    'The following are used only for remote server registration
    strNetworkAddress As String
    strNetworkProtocol As String
    intAuthentication As Integer
    fDCOM As Boolean      ' True if DCOM, otherwise False
End Type

Public Type STARTUPINFO
    cb              As Long
    lpReserved      As Long
    lpDesktop       As Long
    lpTitle         As Long
    dwX             As Long
    dwY             As Long
    dwXSize         As Long
    dwYSize         As Long
    dwXCountChars   As Long
    dwYCountChars   As Long
    dwFillAttribute As Long
    dwFlags         As Long
    wShowWindow     As Integer
    cbReserved2     As Integer
    lpReserved2     As Long
    hStdInput       As Long
    hStdOutput      As Long
    hStdError       As Long
End Type

Public Type PROCESS_INFORMATION
    hProcess    As Long
    hThread     As Long
    dwProcessID As Long
    dwThreadID  As Long
End Type

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Public Type OSVERSIONINFO 'for GetVersionEx API call
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type


'vb6stkit.DLL interfaces
Public Declare Function DllAbortAction Lib "vb6stkit.dll" Alias "AbortAction" () As Long
Public Declare Function DllAddActionNote Lib "vb6stkit.dll" Alias "AddActionNote" (ByVal lpszNote As String) As Long
Public Declare Function DllCommitAction Lib "vb6stkit.dll" Alias "CommitAction" () As Long
Public Declare Function fDllWithinAction Lib "vb6stkit.dll" Alias "fWithinAction" () As Long
Public Declare Function DllLogError Lib "vb6stkit.dll" Alias "LogError" (ByVal lpszERROR As String, ByVal lpszDURINGACTION As String, ByVal lpszErrMsg As String) As Long
Public Declare Function DllLogNote Lib "vb6stkit.dll" Alias "LogNote" (ByVal lpszNote As String) As Long
Public Declare Function DllLogWarning Lib "vb6stkit.dll" Alias "LogWarning" (ByVal lpszWARNING As String, ByVal lpszDURINGACTION As String, ByVal lpszWarningMsg As String) As Long
Public Declare Function DllNewAction Lib "vb6stkit.dll" Alias "NewAction" (ByVal lpszKey As String, ByVal lpszData As String) As Long
Public Declare Function DllEnableLogging Lib "vb6stkit.dll" Alias "EnableLogging" (ByVal lpszFilename As String) As Long
Public Declare Function DllDisableLogging Lib "vb6stkit.dll" Alias "DisableLogging" () As Long
Public Declare Function ExtractFileFromCab Lib "vb6stkit.dll" (ByVal Cab As String, ByVal File As String, ByVal Dest As String, ByVal iCab As Long, ByVal sSrc As String) As Long
Public Declare Function DLLSelfRegister Lib "vb6stkit.dll" (ByVal lpDllName As String) As Integer
Public Declare Function RegisterTLB Lib "vb6stkit.dll" (ByVal lpTLBName As String) As Integer
'Public Declare Function OSfCreateShellLink Lib "vb6stkit.dll" Alias "fCreateShellLink" (ByVal lpstrFolderName As String, ByVal lpstrLinkName As String, ByVal lpstrLinkPath As String, ByVal lpstrLinkArguments As String, ByVal fPrivate As Long, ByVal sParent As String) As Long

'--API ------------------------------
'--kernel32.dll
Public Declare Function LocalFileTimeToFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function SetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Public Declare Function SystemTimeToFileTime Lib "kernel32" (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME) As Long
Public Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Function GetCurrentProcessId Lib "kernel32" () As Long
Public Declare Sub ExitProcess Lib "kernel32" (ByVal uExitCode As Long)
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)
Public Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpcurrDrive As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Long
Public Declare Function OSGetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Public Declare Function GetFullPathName Lib "kernel32" Alias "GetFullPathNameA" (ByVal lpFileName As String, ByVal nBufferLength As Long, ByVal lpBuffer As String, ByRef lpFilePart As Long) As Long
Public Declare Function GetDriveType32 Lib "kernel32" Alias "GetDriveTypeA" (ByVal strWhichDrive As String) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hProcess As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal lSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As Any, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lplFilename As String) As Long
Public Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

'--version.dll
Public Declare Function GetFileVersionInfoSize Lib "version.dll" Alias "GetFileVersionInfoSizeA" (ByVal sFile As String, lpLen As Long) As Long
Public Declare Function GetFileVersionInfo Lib "version.dll" Alias "GetFileVersionInfoA" (ByVal sFile As String, ByVal lpIgnored As Long, ByVal lpSize As Long, ByVal lpBuf As Long) As Long
Public Declare Function VerQueryValue Lib "version.dll" Alias "VerQueryValueA" (ByVal lpBuf As Long, ByVal szReceive As String, lpBufPtr As Long, lLen As Long) As Long
Public Declare Function VerInstallFile Lib "version.dll" Alias "VerInstallFileA" (ByVal flags&, ByVal SrcName$, ByVal DestName$, ByVal SrcDir$, ByVal DestDir$, ByVal CurrDir As Any, ByVal TmpName$, lpTmpFileLen&) As Long
'--oleaut32.dll
Public Declare Function VariantChangeTypeEx Lib "oleaut32.dll" (ByVal pvArgDest As Long, ByVal pvArgSrc As Long, ByVal LCID As Long, ByVal wFlags As Integer, ByVal VarType As Integer) As Long
Public Declare Function VariantTimeToSystemTime Lib "oleaut32.dll" (ByVal vtime As Date, lpSystemTime As SYSTEMTIME) As Long
'--gdi32.dll
Public Declare Function AddFontResource Lib "gdi32" Alias "AddFontResourceA" (ByVal lpFileName As String) As Long
'--user32.dll
Public Declare Function InputIdle Lib "USER32" Alias "WaitForInputIdle" (ByVal hProcess As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function SetWindowPos Lib "USER32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function GetWindowLong Lib "USER32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "USER32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

'--noSE new functions used with no setup.exe:
Public Declare Function DeleteFile Lib "kernel32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long
Public Declare Function CopyFileAPI Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long


'---GLOBAL VARIABLES:
Public IsNT As Boolean           '-- Is it NT/2000/XP? Need to find this out at start.
Public sWinFol As String        '-- Windows folder.
Public sFontFol As String       '-- FONTS folder.
Public sSysFol As String         '-- System folder.
Public sProgFol As String        '-- program files folder.
Public sTempFol As String                '-- temp folder.
Public sTempInstallFol As String         '-- temp install folder in temp folder.
Public sDesktopFol As String
  '-- user's app data folder and name of folder to make in that folder.
  '-- app data folder is set in setup.lst, [Setup] section, as AppDataName value.
  '-- example: AppDataName=Ace and Acme
Public sAppDataFol As String, sAppDataSubFol As String
Public sQLFol As String    '-- quick launch folder path.
Public sStartMenuProgFol As String
Public sLSTFile As String                '--path of setup.lst.
Public sCABPath As String                'path of source files
Public sCABFileName As String                   '-- name of CAB file.
Public sInstallFilesPath As String       '--path of install files (temp folder, usually)
Public sSilentLog As String              ' filename for output during silent install.
Public sAppRemovalLog As String          'name of the app removal logfile
Public sAppRemovalEXE As String          'name of the app removal executable
Public sVerTmpName As String             '-- temp file name.
Public sAppName As String                'name of app being installed
Public sAppTitle As String               '"setup" name of app being installed
Public sAppFolder As String              'dest dir for application files
Public sAppFolTemp As String             '-- temp. var. to hold app folder path if CANCEL in frmpath.
Public sAppEXEName As String
Public sRemIcon As String       '-- DisplayIcon value for Uninstall key. Add AppRemIcon value to Setup section of setup.lst.
Public LRemAppSize As Long      '-- EstimatedSize value for Uninstall key.Add AppSize value to Setup section of setup.lst.
Public PathToGet As String
'
Public GfAppRemovalFilesMoved As Boolean    'whether or not the app removal files have been moved to the application directory
Public MfSinkEvents As Boolean              '--for frmpath.
'
Public msRegInfo() As REGINFO
Public GsDest As DESTINFO                                   'dest dirs for certain files
'

