Attribute VB_Name = "ModEditOps"
Option Explicit
'
'--   This module contains various string ops like
'--   adding quotes, removing quotes, etc.
'-- This is all pretty much original MS code.
'----------------------------------------------------------------------

   '--get string from buffer return in API call:
Public Function StringFromBuffer(Buffer As String) As String
    Dim nPos As Long

    nPos = InStr(Buffer, vbNullChar)
    If nPos > 0 Then
        StringFromBuffer = Left$(Buffer, nPos - 1)
    Else
        StringFromBuffer = Buffer
    End If
End Function
  
  '--add quotes to file name if necessary:
Public Function AddQuotesToFN(ByVal strFilename) As String
    If InStr(strFilename, " ") Or InStr(strFilename, ",") Then
        AddQuotesToFN = QUOTEMARK & strFilename & QUOTEMARK
    Else
        AddQuotesToFN = strFilename
    End If
End Function

Public Function UnQuoteString(ByVal sQt As String) As String
 '--remove quotes around string.
  sQt = Trim$(sQt)
    If (Left$(sQt, 1) = QUOTEMARK) Then sQt = Right(sQt, (Len(sQt) - 1))
    If (Right$(sQt, 1) = QUOTEMARK) Then sQt = Left(sQt, (Len(sQt) - 1))
  UnQuoteString = sQt
End Function

Public Function QuoteString(sUnQt As String, Optional vForce As Boolean = False, Optional vTrim As Boolean = True)
  Dim sQt As String
   sQt = sUnQt
    If vTrim Then
        sQt = Trim$(sQt)
    End If
    
    If Not vForce Then
        If (Left$(sQt, 1) = QUOTEMARK) Then
            If (Right$(sQt, 1) = QUOTEMARK) Then
                GoTo DoneQuoteString
            End If
        End If
    End If
   
    sQt = QUOTEMARK & sQt & QUOTEMARK
DoneQuoteString:
    QuoteString = sQt
End Function

Public Sub AddSlash(sPath As String)
  If (Right$(sPath, 1) <> FORW_SLASH) Then
      If (Right$(sPath, 1) <> BACK_SLASH) Then
          sPath = sPath & BACK_SLASH
      End If
  End If
End Sub

Public Sub SeparatePathAndFileName(FullPath As String, _
    Optional ByRef Path As String, _
    Optional ByRef FileName As String)

    Dim nSepPos As Long
    Dim nSepPos2 As Long
    Dim fUsingDriveSep As Boolean

    nSepPos = InStrRev(FullPath, BACK_SLASH)
    nSepPos2 = InStrRev(FullPath, FORW_SLASH)
    If nSepPos2 > nSepPos Then
        nSepPos = nSepPos2
    End If
    nSepPos2 = InStrRev(FullPath, sCOLON)
    If nSepPos2 > nSepPos Then
        nSepPos = nSepPos2
        fUsingDriveSep = True
    End If

    If nSepPos = 0 Then
        'Separator was not found.
        Path = CurDir$
        FileName = FullPath
    Else
        If fUsingDriveSep Then
            Path = Left$(FullPath, nSepPos)
        Else
            Path = Left$(FullPath, nSepPos - 1)
        End If
        FileName = Mid$(FullPath, nSepPos + 1)
    End If
End Sub

Public Function BaseName(sPathAndFile As String) As String
    ' Strip the path from the file name, and just return the FileName
   Dim sFile As String
     SeparatePathAndFileName sPathAndFile, , sFile
     BaseName = sFile
End Function

Public Function GetShortPathName(ByVal strLongPath As String) As String
    Const cchBuffer = 300
    Dim strShortPath As String
    Dim lResult As Long

    strShortPath = String$(cchBuffer, 0)
    lResult = OSGetShortPathName(strLongPath, strShortPath, cchBuffer)
    If lResult = 0 Then
        'Just use the long name as this is usually good enough
        GetShortPathName = strLongPath
    Else
        GetShortPathName = StringFromBuffer(strShortPath)
    End If
End Function

Public Function strExtractFilenameItem(ByVal str As String, intAnchor As Integer, fErr As Boolean) As String
    Dim iEndFilenamePos As Integer
    Dim strFilename As String
    Dim iCommaPos As Integer

    Do While Mid$(str, intAnchor, 1) = " "
        intAnchor = intAnchor + 1
    Loop

    If Mid$(str, intAnchor, 1) = QUOTEMARK Then
        ' Filename is surrounded by quotes
        iEndFilenamePos = InStr(intAnchor + 1, str, QUOTEMARK) ' Find matching quote
        If iEndFilenamePos > 0 Then
            strFilename = Mid$(str, intAnchor + 1, iEndFilenamePos - 1 - intAnchor)
            intAnchor = iEndFilenamePos + 1
            Do While Mid$(str, intAnchor, 1) = " "
                intAnchor = intAnchor + 1
            Loop
            If intAnchor <= Len(str) Then
                ' If there are any more characters, then the next character
                ' must be a comma.
                If Mid$(str, intAnchor, 1) <> sCOMMA Then
                    fErr = True
                    Exit Function
                End If
            End If
        Else
            fErr = True
            Exit Function
        End If
    Else
        ' Filename continues until next comma or end of string
        iCommaPos = InStr(intAnchor, str, sCOMMA)
        If iCommaPos = 0 Then
            iCommaPos = Len(str) + 1
        End If
        iEndFilenamePos = iCommaPos

        strFilename = Mid$(str, intAnchor, iEndFilenamePos - intAnchor)
        intAnchor = iCommaPos
    End If

    strFilename = Trim$(strFilename)
    If Len(strFilename) = 0 Then
        fErr = True
        Exit Function
    End If

    fErr = False
    strExtractFilenameItem = strFilename
End Function

Public Function ParseDateTime(ByVal strDateTime As String) As Date
    Dim Var As Variant

    Var = strDateTime
    If 0 = VariantChangeTypeEx(VarPtr(Var), VarPtr(Var), &H409, 0, vbDate) Then
        ParseDateTime = Var
    Else
        'Raise same error as CDate
        Err.Raise 13
    End If
End Function

