Attribute VB_Name = "ModFileOps"
Option Explicit
'
'--  ModFileOps contains basic file system operations like
'--  DirExists, FileExists, drive size, etc.

'-- New function to get various system folder paths using API.
Public Function GetFolderPathWSlash(iSys As Integer) As String
    '--0 for windows folder. 1 for system folder. 2 for fonts. 3 for Temp.
  Dim sBuf As String, sRet As String
  Dim LRet As Long
   On Error Resume Next
    sBuf = String$(MAX_PATH, 0)
     Select Case iSys
       Case 0
         LRet = GetWindowsDirectory(sBuf, MAX_PATH)
         If (LRet > 0) Then sRet = Left$(sBuf, LRet)
       Case 1
         LRet = GetSystemDirectory(sBuf, MAX_PATH)
         If (LRet > 0) Then sRet = Left$(sBuf, LRet)
       Case 2
         sRet = GetFolPath(CSIDL_FONTS)
       Case 3
         LRet = GetTempPath(MAX_PATH, sBuf)
         If (LRet > 0) Then sRet = Left$(sBuf, LRet)
     End Select
     
    If (Len(sRet) > 0) Then
      AddSlash sRet
    End If
     GetFolderPathWSlash = sRet
End Function

Public Function strGetCommonFilesPath() As String
  Dim sPath As String
    sPath = RegGetString(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion", "CommonFilesDir")
      If (Len(sPath) > 0) Then
          AddSlash sPath
      End If
    strGetCommonFilesPath = sPath
End Function

Public Function TestWriteAccess(ByVal sFolPath As String) As Boolean
    Const strFILE$ = "VB6STTMP.CCT"
    Dim F1 As Integer
       On Error Resume Next

    AddSlash sFolPath
    F1 = FreeFile
    Open sFolPath & strFILE For Output As F1
    TestWriteAccess = (Err.Number = 0)
    Close F1
    Kill sFolPath & strFILE
    Err.Clear
End Function

Public Function FileExists(ByVal strPathName As String) As Boolean
  Dim intFileNum As Integer
   On Error Resume Next

    strPathName = UnQuoteString(strPathName)
   
    If Right$(strPathName, 1) = BACK_SLASH Then
        strPathName = Left$(strPathName, Len(strPathName) - 1)
    End If

    intFileNum = FreeFile
    Open strPathName For Input As intFileNum
        FileExists = (Err.Number = 0)
    Close intFileNum
      Err.Clear
End Function

Public Function DirExists(ByVal strDirName As String) As Boolean
  On Error Resume Next
    DirExists = (GetAttr(strDirName) And vbDirectory) = vbDirectory
    Err.Clear
End Function

Public Function GetDriveSpace(sPath) As Long
   '--get free and total of drive passed.
   Dim cuBytesFree As Currency, cuTotal As Currency, cuTotalFree As Currency
   Dim LRet As Long, CFree As Currency, tot As Currency
   Dim LFree As Long
   Dim sDriv As String
    On Error GoTo woops
     If Len(sPath) > 1 Then
       sDriv = Left$(sPath, 1)
       sDriv = sDriv & ":\"
     End If
     If sDriv = "a:\" Then
       GetDriveSpace = 0
       Exit Function
     End If
     LRet = GetDiskFreeSpaceEx(sDriv, cuBytesFree, cuTotal, cuTotalFree)
      If LRet <> 0 Then
         CFree = (cuBytesFree * 10000) / 1024 / 1024
         LFree = CLng(CFree)
         GetDriveSpace = LFree
      End If
   Exit Function
woops:
  GetDriveSpace = 0
End Function

Public Function GetDrive(ByVal sPath As String, sDriv As String) As Boolean
  Dim boo As Boolean
  Dim s As String
   On Error Resume Next
   boo = False
  If Len(sPath) < 2 Then
     GetDrive = False
     Exit Function
  End If
    
      If InStr(2, sPath, sCOLON) = 2 Then
         sDriv = LCase$(Left$(sPath, 2)) & BACK_SLASH
         boo = True
      End If

   GetDrive = boo
End Function

Public Function strRootDrive() As String
    Dim intDriveNum As Integer
    
    For intDriveNum = 0 To Asc("Z") - Asc("A")
        If GetDriveType(intDriveNum) = intDRIVE_FIXED Then
            strRootDrive = Chr$(Asc("A") + intDriveNum) & sCOLON & BACK_SLASH
            Exit Function
        End If
    Next intDriveNum

    strRootDrive = "C:\"
End Function

Public Function GetDriveType(ByVal intDriveNum As Integer) As Integer
    '
    ' This function expects an integer drive number in Win16 or a string in Win32
    '
    Dim strDriveName As String

    strDriveName = Chr$(Asc("A") + intDriveNum) & sCOLON & BACK_SLASH
    GetDriveType = CInt(GetDriveType32(strDriveName))
End Function

Public Function CheckDrive(ByVal strDrive As String) As Boolean
    Dim strDir As String
    Dim strMsg As String
    Dim strNewDrive As String

    On Error Resume Next

    Screen.MousePointer = 11
    GetDrive strDrive, strNewDrive
  Do
    Err.Clear
    strDir = Dir$(strNewDrive)
     If Err.Number = 0 Then
        CheckDrive = True
        Exit Do
     Else
           
      strMsg = "Error: " & Err.Description & vbCrLf & "Drive " & strDrive & " is not ready."
          
            If MsgBox(strMsg, vbRetryCancel, sSETUP) = vbCancel Then
                'The user wants to cancel, so fall out of the loop and return
                '   False implicitly.
                'CheckDrive = False (implicit)
                Exit Do
            End If
           
      End If
    Loop

   Screen.MousePointer = 0

    Err.Clear
End Function

'-- get file extension.
Public Function GetFileExtension(ByVal sPath As String) As String
    Dim PtDot As Long
    Dim sExt As String
  On Error GoTo woops
    PtDot = InStrRev(sPath, cDOT)
     If (PtDot > 0) Then
       sExt = Right$(sPath, (Len(sPath) - PtDot))
         If (InStr(sExt, BACK_SLASH) = 0) And (InStr(sExt, FORW_SLASH) = 0) Then
            GetFileExtension = UCase$(sExt)
         End If
     End If
    
    Exit Function
woops:
    GetFileExtension = ""
End Function

Public Function GetFileVerStruct(ByVal sFile As String, sVer As VERINFO) As Boolean
  '--get file version info.
    Const sEXE As String = "\"
    Dim lVerSize As Long
    Dim lTemp As Long
    Dim LRet As Long
    Dim bInfo() As Byte
    Dim lpBuffer As Long
    Dim fFoundVer As Boolean
     On Error Resume Next
        fFoundVer = False
        'Get the size of the file version info, allocate a buffer for it, and get the
        'version info.  Next, we query the Fixed file info portion, where the internal
        'file version used by the Windows VerInstallFile API is kept.  We then copy
        'the fixed file info into a VERINFO structure.
        '
        lVerSize = GetFileVersionInfoSize(sFile, lTemp)
        ReDim bInfo(lVerSize)
        If lVerSize > 0 Then
            LRet = GetFileVersionInfo(sFile, lTemp, lVerSize, VarPtr(bInfo(0)))
            If LRet <> 0 Then
                LRet = VerQueryValue(VarPtr(bInfo(0)), sEXE, lpBuffer, lVerSize)
                If LRet <> 0 Then
                    CopyMemory sVer, ByVal lpBuffer, lVerSize
                    fFoundVer = True
                End If
            End If
        End If
  
    GetFileVerStruct = fFoundVer
End Function

  '-- This is a condensation of 3 functions. The original was
  '-- written with this function plus "IsWindows95". Both called
  '-- a 3rd function that called GetVersionEx! That whole mess
  '-- was called several times. It was all replaced with this single
  '-- function called at the beginning, which stores the result in
  '-- the global boolean variable IsNT and then uses that variable for
  '-- all OS checks.
Public Function IsWindowsNT() As Boolean
  Dim OSV As OSVERSIONINFO
    OSV.dwOSVersionInfoSize = Len(OSV)
       If GetVersionEx(OSV) = 0 Then Exit Function
    IsWindowsNT = (OSV.dwPlatformId = 2)
End Function

 '-- From here down are 3 basic file system functions added
 '-- for operations needed when skipping setup.exe.
Public Sub jsWriteFile(sFilPath As String, ByVal sText As String)
 Dim FF As Integer
   On Error Resume Next
    jsDeleteFile sFilPath
   
     FF = FreeFile()
    Open sFilPath For Output As #FF
      Print #FF, sText;
    Close #FF
    
End Sub

Public Sub jsDeleteFile(sDeletePath As String)
  '--delete a file. --------------------------
  Dim i As Integer
  Dim LDel As Long
  On Error Resume Next
   Err.Clear
   i = GetAttr(sDeletePath)
   If (Err.Number <> 0) Then Exit Sub
   SetAttr sDeletePath, 0
   LDel = DeleteFile(sDeletePath)
 
End Sub

Public Sub jsCopyFile(fPath As String, fMoveTo As String)
 '--move a file. --------------
 Dim LRet As Long, LDel As Long, T As Long
 Dim iAtr As Integer
   On Error Resume Next
   Err.Clear
    iAtr = GetAttr(fPath)
    If Err.Number <> 0 Then Exit Sub
 
   jsDeleteFile fMoveTo
  
   T = 0
   SetAttr fPath, 0
   LRet = CopyFileAPI(fPath, fMoveTo, ByVal T)
   jsDeleteFile fPath
End Sub


