Attribute VB_Name = "ModFormOps"
Option Explicit

'-----------------------------------------------------------------------
'---------  ModFormOps contains functions for color gradient, borderizing
'---------  forms, showing forms, etc.
'-----------------------------------------------------------------------

Public Sub Borderize(ByVal LHandle As Long)
 '--add borders to frames
  Dim LRet As Long, LOpts As Long
     On Error Resume Next
       '-- This hard codes a light border around all windows (and optionally
       '-- around frames). See the borderizing constants section in ModDeclares
       '-- for ideas about other options such as sunken, raised, sunken AND raised, etc.
   LOpts = WINDOW_FRAME_2
   LRet = GetWindowLong(LHandle, GWL_EXSTYLE)
   LRet = LRet Or LOpts
    Call SetWindowLong(LHandle, GWL_EXSTYLE, LRet)
    SetWindowPos LHandle, 0, 0, 0, 0, 0, swpFlags
End Sub

Public Sub ColorBack(Frm As Form, LWidth As Single, LHeight As Single, TLCol As String, BRCol As String)
  '-- color gradient on backgrounds, left top dark to bottom right light.
  '-- Before calling: ScaleMode of form is changed to pixels before calling
  '-- this sub, so that LWidth and LHeight will be pixel values.
  '-- This code creates gradient from 0,0 (top-left) out to bottom-right,
  '-- but it doesn't have to be done that way.
  
  '-- TLCol and BRCol are top-right color and bottom-right color. They should
  '-- be sent in as 6-char. HTML hex codes: "RRGGBB"
  
  '--WIDTH SHOULD BE GREATER THAN HEIGHT!!
  Dim R1 As Integer, R2 As Integer, G1 As Integer, G2 As Integer
  Dim B1 As Integer, B2 As Integer
  Dim PtS As Single, PtE As Single, CurPt As Single, Pt2 As Single
  
  Dim DifB As Single, DifR As Single, DifG As Single
  Dim LTot As Single
   On Error Resume Next
   
     '-- convert top-left color hex code to RGB:
      R1 = CInt("&H" & Left$(TLCol, 2))
      G1 = CInt("&H" & Mid$(TLCol, 3, 2))
      B1 = CInt("&H" & Right$(TLCol, 2))
      
     '-- convert bottom-right color hex code to RGB:
      R2 = CInt("&H" & Left$(BRCol, 2))
      G2 = CInt("&H" & Mid$(BRCol, 3, 2))
      B2 = CInt("&H" & Right$(BRCol, 2))
   
    
      '--total number of lines:
   LTot = LWidth + (LHeight * 2)
   
     '--get difference between each line:
   DifB = (B2 - B1) / LTot
   DifG = (G2 - G1) / LTot
   DifR = (R2 - R1) / LTot
   
   With Frm
     .DrawStyle = vbInsideSolid
     .DrawMode = vbCopyPen
     .DrawWidth = 1
   End With
   
   '--go down left side, up diagonally:
   For PtS = 1 To LHeight
       Frm.Line (0, PtS)-(PtS, 0), RGB( _
         (R1 + (PtS * DifR)), (G1 + (PtS * DifG)), (B1 + (PtS * DifB)))
   Next
 
   '--go along top, down diagonally:
 
   For PtS = LHeight To LWidth
         Frm.Line (PtS, 1)-((PtS - LHeight), LHeight), RGB( _
          (R1 + (PtS * DifR)), (G1 + (PtS * DifG)), (B1 + (PtS * DifB)))
   Next
  
   '--go along right down to bottom:
   CurPt = (LWidth - LHeight)
    For PtS = 1 To LHeight
      PtE = LWidth + PtS
         Frm.Line (LWidth, PtS)-((CurPt + PtS), LHeight), RGB( _
           (R1 + (PtE * DifR)), (G1 + (PtE * DifG)), (B1 + (PtE * DifB)))
    Next
   
       Frm.ScaleMode = vbTwips
       Frm.Refresh
End Sub

 '-- show frmPath for path selection. This is used for
  '-- two different situations: If PathToGet is "prog" then
  '-- it's used to choose a substitute for the program files folder
  '-- at the beginning of setup, so that app. path folder string can be
  '-- created. Otherwise it's used when installer wants to change
  '-- installation directory in the frmBegin window.

Public Sub ShowPathForm(sTit As String)
 Dim sDriv As String
  On Error Resume Next
 If PathToGet = "prog" Then
   sDriv = Left$(sWinFol, 2)
    If Right$(sDriv, 1) = sCOLON Then
       sDriv = Left$(sWinFol, 1)
      With frmPath
         .drvDrives.Drive = sDriv
         .dirDirs.Path = .drvDrives.Drive
         .lblPrompt.Caption = sTit
         .txtPath.Text = ""
      End With
    End If
 Else
    sDriv = Left$(sAppFolder, 1)
       With frmPath
         .drvDrives.Drive = sDriv
         .dirDirs.Path = .drvDrives.Drive
         .lblPrompt.Caption = sTit
         .txtPath.Text = sAppFolder
       End With
    
 End If
   MfSinkEvents = True
   frmPath.Show 0
End Sub

 '-- sets app. folder path in frmBegin window and shows it.
  '-- from there installer can either proceed, cancel, or change app. folder path.
Public Sub ShowBeginInstall()
   frmBegin.lblDestDir.Caption = sAppFolder
   frmBegin.Show 0
   fWelcome.Hide
End Sub

   '--update path on frmBegin and set focus to install button:
Public Sub ResetBeginPath()
  On Error Resume Next
   With frmBegin
     .lblDestDir.Caption = sAppFolder
     .cmdInstall.SetFocus
   End With
End Sub

