Attribute VB_Name = "ModInstall"
Option Explicit

' SUB: CopySection
' Attempts to copy the files that need to be copied from
' the named section of the setup info file (SETUP.LST)

'--this function has been weeded to eliminate weird and confusing double-negatives.
'-- multiple variables for the same thing, etc.
Public Sub CopySection()
    Dim intIdx As Integer
    Dim sFile As FILEINFO
    Dim sSrcFilePath As String
    Dim sDestDir As String
    Dim sDestFileName As String
    Dim sDestFilePath As String
    Dim strRegister As String
    Dim strExt As String
    Dim sCurDate As String
    Dim sFileDate As String
    Dim lTime As FILETIME
    Dim hFile As Long
    Dim strDestVer As String
    Dim Boo1 As Boolean
    Dim BooInstall As Boolean '--this is to get rid of confusing double-negatives,
    '-- superfluous Enums and boolean values, etc. Original code uses an enum
    '-- for whether to copy and another enum for whether installing file is
    '--newer. Those enums are not only unnecessary but also confusing, with
    '-- "owYes" meaning "DON'T install file" and "owNo" meaning "DO install file"!

       On Error Resume Next
    
      '--make sure that temp folder exists (i.e. C:\Windows\TEMP\msftqws.pdw\
    If Not FileExists(sTempInstallFol) Then
      If (DirExists(sTempInstallFol) = False) Then
        MkDir sTempInstallFol
      End If
    End If
    
    '-- For each file in the [Setup1 Files] section of setup.lst, read line.
    '-- sFile is returned as a FILEINFO structure that contains data from line.
    intIdx = 1
  Do While ReadSetupFileLine(intIdx, sFile) '--work out string for each install file listed.
      
   '----EXTRACT each file from CAB into TEMP\abcde.pdw\
        sSrcFilePath = sTempInstallFol & sFile.strDestName '-- TEMP\abcde.pdw\filename
        
   '-- extract files from TEMP\CAB into TEMP\abcde.pdw\ folder
        ExtractFileFromCab sCABPath, sFile.strSrcName, sSrcFilePath, 1, sInstallFilesPath
  '-- ex: (Windows\ABC-Ed.cab, filename, TEMP\abcde.pdw\filename, 1, [wherever install files are - generally TEMP\])
          
       If FileExists(sSrcFilePath) Then '--if extracted successfully:
          sFile.strSrcName = sSrcFilePath
       Else   ' Can't find the file.
          MsgBox "Unable to locate installation files. Setup must exit.", 64, sSETUP
          ExitSetup GintRET_FATAL
       End If
                   '-- functions taken out to prompt for next disk.
                   '-- this version of install cannot be on 2 floppies.
              
         sDestDir = sFile.strDestDir
         sDestFileName = sFile.strDestName
         MakePath sDestDir, True
           sDestDir = GetLongPath(sDestDir)
         AddSlash sDestDir
         sDestFilePath = sDestDir & sDestFileName
         
         'Cache the UCase of the extension, for use below
        strExt = GetFileExtension(sDestFileName)
            If strExt = GsEXT_FONTTTF Then 'Both strExt and gsEXT_FONTTTF are uppercase
                'No new actions for fonts
            ElseIf strExt = GsEXT_FONTFON Then 'Both strExt and gsEXT_FONTFON are uppercase
                'No new actions for fonts
            ElseIf sFile.fShared Then
                NewAction GstrKEY_SHAREDFILE, QUOTEMARK & sDestFilePath & QUOTEMARK
            ElseIf sFile.fSystem Then
                NewAction GstrKEY_SYSTEMFILE, QUOTEMARK & sDestFilePath & QUOTEMARK
            ElseIf strExt = UCase$(GsEXT_REG) Then 'strExt is uppercase; gsEXT_REG is not
                If GetFileExtension(sFile.strRegister) = UCase$(GsEXT_REG) Then
                    'No new actions for registration files.
                Else
                    NewAction GstrKEY_PRIVATEFILE, QUOTEMARK & sDestFilePath & QUOTEMARK
                End If
            Else
                NewAction GstrKEY_PRIVATEFILE, QUOTEMARK & sDestFilePath & QUOTEMARK
            End If
        
        
        If UCase$(sDestFileName) = UCase$(sAppEXEName) Then
               'Used for creating a program manager icon in Form_Load of SETUP1.FRM
               'and for registering the per-app path
            GsDest.strAppDir = sDestDir
        End If
        
      BooInstall = True
               'Special case for RICHED32.DLL
               ' we only install this file under Windows 95, not under Windows NT
        If UCase$(sDestFileName) = "RICHED32.DLL" Then
            If (IsNT = True) Then
                'We're not running under Win95 - do not install this file.
                BooInstall = False
                LogNote "RICHED32.DLL not copied because not needed on NT."
                AbortAction
            End If
        End If

        strRegister = sFile.strRegister
        
        'Next we'll deal with whether this file needs upgrading.
  
       If (BooInstall = True) Then '-- not RichEd on NT.
             BooInstall = SourceFileIsNewer(sFile, sSrcFilePath, sTempInstallFol, sDestFileName, sDestDir, strDestVer)
           If (BooInstall = False) Then  '-- install file is not newer; don't upgrade.
               If (strExt <> GsEXT_FONTTTF) And (strExt <> GsEXT_FONTFON) Then
                  DecideIncrementRefCount sDestFilePath, sFile.fShared, sFile.fSystem, True
                   If (Len(sAppDataFol) > 0) And (InStr(1, sDestDir, sAppDataFol, 1) = 0) Then '-- not an app data file.
                      AddActionNote "Currently installed file was up to date."
                      CommitAction
                   Else
                      AbortAction
                   End If
               End If
           End If
       End If
        
        'After all of this, if we're still ready to copy, then give it a whirl!
        '-- copy new file to replacement location:
        
        If (BooInstall = True) Then  '--copy file to system.
            SetAttr sDestFilePath, vbNormal
           If GetFileExtension(sFile.strRegister) <> UCase$(GsEXT_REG) Then
              Boo1 = CopyFile(sTempInstallFol, sDestDir, sDestFileName, sDestFileName, sFile.fShared, sFile.fSystem)
           End If
        End If
        '
        'Register fonts
        '
        Select Case strExt
        Case GsEXT_FONTTTF, GsEXT_FONTFON 'strExt, gsEXT_FONTTTF, and gsEXT_FONTFON are all uppercase
            AddFontResource sDestFilePath
        End Select
        '
       
            'If we successfully copied the file, and if registration information was
            'specified in the setup info file, save the registration info into an
            'array so that we can register all files requiring it in one fell swoop
            'after all the files have been copied.
            '
            If (Len(strRegister) > 0) Then
                Err.Clear
                ReDim Preserve msRegInfo(UBound(msRegInfo) + 1)

                If Err.Number <> 0 Then
                    ReDim msRegInfo(0)
                End If

                msRegInfo(UBound(msRegInfo)).strFilename = sDestFilePath

                Select Case UCase$(strRegister)
                    Case MstrDLLSELFREGISTER, MstrEXESELFREGISTER, MstrTLBREGISTER, MstrVBLREGISTER 'These are all uppercase
                        'Nothing in particular to do
                    Case Else
                        '
                        'If the registration info specified the name of a file with
                        'registration info (which we assume if a registration macro
                        'was not specified), then we also assume that, if no path
                        'information is available, this reginfo file is in the same
                        'directory as the file it registers
                        '
                        strRegister = ResolveDestDirs(strRegister)
                        If InStr(strRegister, BACK_SLASH) = 0 Then 'This search is case-sensitive, as it should be
                            strRegister = sTempInstallFol & strRegister
                        End If
                End Select

                If GetFileExtension(strRegister) = UCase$(GsEXT_REG) Then
                    SyncShell GsREGEDIT & QuoteString(strRegister), INFINITE
                End If
                msRegInfo(UBound(msRegInfo)).strRegister = strRegister
          End If
    


CSContinue:
      

        sFileDate = Format$(FileDateTime(sDestFilePath), "m/d/yyyy h:m")
        sCurDate = Format$(Now, "m/d/yyyy h:m")

        If sFileDate = sCurDate Then
            lTime = GetFileTime(sFile.varDate)
            hFile = CreateFile(sDestFilePath, GENERIC_WRITE Or GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
            SetFileTime hFile, lTime, lTime, lTime
            DoEvents
            CloseHandle hFile
        Else
            '
            'Give a chance for the 'Cancel' button command to be processed if it was pressed
            '
            DoEvents
        End If
        'Delete the files after copy...
        SetAttr sSrcFilePath, vbNormal
        Kill sSrcFilePath
        intIdx = intIdx + 1
    Loop

    Err.Clear
End Sub


'-----------------------------------------------------------
' SUB: ReadSetupFileLine
'
' Reads the requested 'FileX=' key from the specified
' section of the setup information file (SETUP.LST).
'
' IN: [strSection] - name of section to read from SETUP.LST,
'                    Ex: "Files"
'     [intFileNum] - file number index to read
'
' OUT: [sFile] - FILEINFO Type variable that, after parsing,
'                holds the information for the file
'                described.
'
' Returns: True if the requested info was successfully read,
'          False otherwise
'-----------------------------------------------------------

Public Function ReadSetupFileLine(ByVal intFileNum As Integer, sFile As FILEINFO) As Integer
    Dim strLine As String
    Dim strMsg As String
    Dim intOffset As Integer
    Dim intAnchor As Integer
    Dim fDone As Integer
    Dim fErr As Boolean
    Dim strVersion As String
    Dim strFilename As String

    Dim strInitialDestDir As String

    Dim strShareType As String

    sFile.fSystem = False
    sFile.fShared = False
    
    '
    ' Read the requested line, if unable to read it (Len(strLine) = 0) then exit
    '
    strLine = ReadIniFile(sLSTFile, "Setup1 Files", "File" & Format$(intFileNum))
    If Len(strLine) = 0 Then
        Exit Function
    End If

    '
    'source file name, ensure it's not a UNC name
    '
    intAnchor = 1
    sFile.strSrcName = strExtractFilenameItem(strLine, intAnchor, fErr)
    If fErr Then GoTo RSFLError

    intAnchor = intAnchor + 1 'Skip past the comma
    
    '
    'dest file name, ensure it's not a UNC name
    '
    If Left$(sFile.strSrcName, 1) = cATSIGN Then
        sFile.strDestName = Mid$(sFile.strSrcName, 2)
    Else
        sFile.strDestName = sFile.strSrcName
    End If
    SeparatePathAndFileName sFile.strDestName, , strFilename
    '
    'parse and resolve destination directory
    '
    intOffset = intGetNextFldOffset(intAnchor, strLine, sCOMMA)
    If intOffset > 0 Then
        strInitialDestDir = Mid$(strLine, intAnchor, intOffset - intAnchor)
        If InStr(UCase$(strInitialDestDir), UCase$(GstrWINSYSDESTSYSFILE)) = 1 Then
            sFile.fSystem = True
        End If
      
        sFile.strDestDir = ResolveDestDir(strInitialDestDir)
        If sFile.strDestDir <> "?" Then
            sFile.strDestDir = ResolveDir(sFile.strDestDir, False, False)
            If Len(sFile.strDestDir) = 0 Then 'Or IsUNCName(sFile.strDestDir) Then
                GoTo RSFLError
            End If
        End If
    Else
        GoTo RSFLError
    End If

    '
    'file registration information
    '
    intAnchor = intOffset + 1
    intOffset = intGetNextFldOffset(intAnchor, strLine, sCOMMA)
    If intOffset > 0 Then
        sFile.strRegister = Mid$(strLine, intAnchor, intOffset - intAnchor)
    Else
        GoTo RSFLError
    End If

    '
    'Extract file share type
    '
    intAnchor = intOffset + 1
    intOffset = intGetNextFldOffset(intAnchor, strLine, sCOMMA)
    sFile.fShared = False
    If intOffset > 0 Then
        strShareType = Mid$(strLine, intAnchor, intOffset - intAnchor)
        Select Case UCase$(strShareType)
            Case UCase$(MstrPRIVATEFILE)
                sFile.fShared = False
            Case UCase$(MstrSHAREDFILE)
                If sFile.fSystem Then
                    'A file cannot be both system and shared
                    GoTo RSFLError
                End If
                
                sFile.fShared = True
            Case Else
                GoTo RSFLError
        End Select
    End If
    
    '
    'Extract file date and convert to a date variant
    '
    intAnchor = intOffset + 1
    intOffset = intGetNextFldOffset(intAnchor, strLine, sCOMMA)
    If intOffset > 0 Then
        On Error GoTo RSFLError
        sFile.varDate = ParseDateTime(Mid$(strLine, intAnchor, intOffset - intAnchor))
        On Error GoTo 0
    End If

    '
    'Get file size
    '
    intAnchor = intOffset + 1
    intOffset = intGetNextFldOffset(intAnchor, strLine, sCOMMA)
    If intOffset > 0 Then
        sFile.lFileSize = Val(Mid$(strLine, intAnchor, intOffset - intAnchor))
    Else
        GoTo RSFLError
    End If

    '
    ' Get the version number, otherwise flag that there is no version info
    '
    intAnchor = intOffset + 1
    If intOffset > 0 Then
        strVersion = Trim$(Right$(strLine, Len(strLine) - intOffset))
        If Len(strVersion) = 0 Then
            sFile.sVerInfo.FileVerPart1 = GintNOVERINFO
        Else
            PackVerInfo strVersion, sFile.sVerInfo
        End If
    Else
        GoTo RSFLError
    End If
    
RSFLDone:
    ReadSetupFileLine = True
    Exit Function

RSFLError:
    strMsg = "Invalid line in setup file - " & sLSTFile & vbCrLf
    strMsg = strMsg & "Section: Setup1 Files" & vbCrLf & strLine
    MsgBox strMsg, 64, sSETUP
    ExitSetup GintRET_FATAL
End Function

Public Sub PackVerInfo(ByVal strVersion As String, sVerInfo As VERINFO)
    Dim intOffset As Integer
    Dim intAnchor As Integer

    On Error GoTo PVIError

    intOffset = InStr(strVersion, cDOT)
    If intOffset = 0 Then
        sVerInfo.FileVerPart1 = Val(strVersion)
        GoTo PVIMSLo
    Else
        sVerInfo.FileVerPart1 = Val(Left$(strVersion, intOffset - 1))
        intAnchor = intOffset + 1
    End If

    intOffset = InStr(intAnchor, strVersion, cDOT)
    If intOffset = 0 Then
        sVerInfo.FileVerPart2 = Val(Mid$(strVersion, intAnchor))
        GoTo PVILSHi
    Else
        sVerInfo.FileVerPart2 = Val(Mid$(strVersion, intAnchor, intOffset - intAnchor))
        intAnchor = intOffset + 1
    End If

    intOffset = InStr(intAnchor, strVersion, cDOT)
    If intOffset = 0 Then
        sVerInfo.FileVerPart3 = Val(Mid$(strVersion, intAnchor))
        GoTo PVILSLo
    Else
        sVerInfo.FileVerPart3 = Val(Mid$(strVersion, intAnchor, intOffset - intAnchor))
        intAnchor = intOffset + 1
    End If

    intOffset = InStr(intAnchor, strVersion, cDOT)
    If intOffset = 0 Then
        sVerInfo.FileVerPart4 = Val(Mid$(strVersion, intAnchor))
    Else
        sVerInfo.FileVerPart4 = Val(Mid$(strVersion, intAnchor, intOffset - intAnchor))
    End If

    Exit Sub

PVIError:
    sVerInfo.FileVerPart1 = 0
PVIMSLo:
    sVerInfo.FileVerPart2 = 0
PVILSHi:
    sVerInfo.FileVerPart3 = 0
PVILSLo:
    sVerInfo.FileVerPart4 = 0
End Sub

Public Function ResolveDir(ByVal strPathName As String, fMustExist As Integer, fWarn As Integer) As String
    Dim strMsg As String
    Dim fInValid As Integer
    Dim strUnResolvedPath As String
    Dim strResolvedPath As String
    Dim nIgnore As Long
    Dim cbResolved As Long
    Dim strDummy As String
      On Error Resume Next
  
    If FileExists(strPathName) Then
        fInValid = True
        GoTo RDContinue
    End If

    strUnResolvedPath = strPathName

    If InStr(3, strUnResolvedPath, BACK_SLASH) > 0 Then

        strResolvedPath = String$(MAX_PATH, 0)
        cbResolved = GetFullPathName(strUnResolvedPath, MAX_PATH, strResolvedPath, nIgnore)
        If cbResolved = 0 Then
           
            AddSlash strUnResolvedPath
            If DirExists(strUnResolvedPath) Then
                strResolvedPath = strUnResolvedPath
            Else
                fInValid = True
            End If
        Else
            strResolvedPath = StringFromBuffer(strResolvedPath)
            If Not CheckDrive(strResolvedPath) Then
                fInValid = True
            Else
                AddSlash strResolvedPath
                If fMustExist Then
                    Err.Clear
                    strDummy = Dir$(strResolvedPath & "*.*")
                    
                    If Err.Number <> 0 Then
                        strMsg = "The folder does not exist." & vbLf & vbLf
                        fInValid = True
                    End If
                End If
            End If
        End If
    Else
        fInValid = True
    End If

RDContinue:
    If fInValid Then
        ResolveDir = vbNullString
    Else
        ResolveDir = strResolvedPath
    End If

    Err.Clear
End Function


Public Function ResolveDestDir(ByVal strDestDir As String, Optional fAssumeDir As Boolean = True) As String
    Const strMACROSTART$ = "$("
    Const strMACROEND$ = ")"

    Dim intPos As Integer
    Dim strResolved As String
    Dim hKey As Long
    Dim strPathsKey As String
    Dim fQuoted As Boolean
    
    Const strProgramFilesKey = "ProgramFilesDir"

    Dim strCommonFiles As String

    strPathsKey = "SOFTWARE\Microsoft\Windows\CurrentVersion"
    strDestDir = Trim$(strDestDir)
    '
    ' If strDestDir is quoted when passed to this routine, it
    ' should be quoted when it's returned.  The quotes need
    ' to be temporarily removed, though, for processing.
    '
    If Left$(strDestDir, 1) = QUOTEMARK Then
        fQuoted = True
        strDestDir = UnQuoteString(strDestDir)
    End If
    '
    ' We take the first part of destdir, and if its $( then we need to get the portion
    ' of destdir up to and including the last paren.  We then test against this for
    ' macro expansion.  If no ) is found after finding $(, then must assume that it's
    ' just a normal file name and do no processing.  Only enter the case statement
    ' if strDestDir starts with $(.
    '
    If Left$(strDestDir, 2) = strMACROSTART Then
        intPos = InStr(strDestDir, strMACROEND)

        Select Case UCase$(Left$(strDestDir, intPos))
            Case UCase$(GstrAPPDEST)    '-- file goes to AppPath.
                If Len(sAppFolder) > 0 Then
                    strResolved = sAppFolder
                Else
                    strResolved = "?"
                End If
                '-- New code here to provide a hard-coded App. Data path option.
                '-- Case UCase$(GstrAPPDATA) means that the file listed under [Setup1 Files]
                '-- in setup.lst had a string like:
                '--    File1=@somepic.gif,$(AppData),,, etc.
                '--
            Case UCase$(GstrAPPDATA)  '-- File goes to Application data\CompanyName.
                If Len(sAppDataFol) > 0 Then
                  strResolved = sAppDataFol
                Else
                  strResolved = sAppFolder
                End If
                
            Case UCase$(GstrWINDEST) '-- Windows.
                strResolved = sWinFol
                
            Case UCase$(GstrFONTDEST)   '-- font folder.
                strResolved = sFontFol
                
            Case UCase$(GstrWINSYSDEST), UCase$(GstrWINSYSDESTSYSFILE)
                strResolved = sSysFol
                
            Case UCase$(GstrPROGRAMFILES)
                strResolved = sProgFol
                  If Len(strResolved) = 0 Then
                    'If not otherwise set, let strResolved be the root of the first fixed disk
                    strResolved = strRootDrive()
                  End If
                  
            Case UCase$(GstrCOMMONFILES)
                'First determine the correct path of Program Files\Common Files, if under Win95
                strResolved = strGetCommonFilesPath()
                If Len(strResolved) = 0 Then
                    'If not otherwise set, let strResolved be the Windows directory
                    strResolved = sWinFol
                End If
                
            Case UCase$(GstrCOMMONFILESSYS)
                'First determine the correct path of Program Files\Common Files, if under Win95
                strCommonFiles = strGetCommonFilesPath()
                If Len(strCommonFiles) > 0 Then
                    'Okay, now just add \System, and we're done
                    strResolved = strCommonFiles & "System\"
                Else
                    'If Common Files isn't in the registry, then map the
                    'entire macro to the Windows\{system,system32} directory
                    strResolved = sSysFol
                End If
                
            Case Else
                intPos = 0
        End Select
    End If
    
    If intPos <> 0 Then
        AddSlash strResolved
    End If

    If fAssumeDir Then
        If intPos = 0 Then
            '
            'if no drive spec, and doesn't begin with any root path indicator ("\"),
            'then we assume that this destination is relative to the app dest dir
            '
            If Mid$(strDestDir, 2, 1) <> sCOLON Then
                If Left$(strDestDir, 1) <> BACK_SLASH Then
                    strResolved = sAppFolder
                End If
            End If
        Else
            If Mid$(strDestDir, intPos + 1, 1) = BACK_SLASH Then
                intPos = intPos + 1
            End If
        End If
    End If

    If fQuoted Then
        ResolveDestDir = QuoteString(strResolved & Mid$(strDestDir, intPos + 1), True, False)
    Else
        ResolveDestDir = strResolved & Mid$(strDestDir, intPos + 1)
    End If
End Function

Private Function ResolveDestDirs(str As String)
    Dim intAnchor As Integer
    Dim intOffset As Integer
    Dim strField As String
    Dim strExpField As String
    Dim strExpanded As String
    
    If Len(Trim$(UnQuoteString(str))) = 0 Then
        ResolveDestDirs = str
        Exit Function
    End If

    intAnchor = 1

    Do
        intOffset = intGetNextFldOffset(intAnchor, str, " ")
        If intOffset = 0 Then intOffset = Len(str) + 1
        strField = Mid$(str, intAnchor, intOffset - intAnchor)
        strExpField = ResolveDestDir(strField, False)
        strExpanded = strExpanded & strExpField & " "
        intAnchor = intOffset + 1
    Loop While intAnchor < Len(str)
    
    ResolveDestDirs = Trim$(strExpanded)
End Function

Public Function intGetNextFldOffset(ByVal intAnchor As Integer, strList As String, strDelimit As String) As Integer
'
' This routine reads from a strDelimit separated list, strList, and locates the next
' item in the list following intAnchor.  Basically it finds the next
' occurance of strDelimit that is not inside quotes.  If strDelimit is not
' found the routine returns 0.  Note intAnchor must be outside of quotes
' or this routine will return incorrect results.
'
' strDelimit is typically a comma.
'
' If there is an error this routine returns -1.
'
    Dim intQuote As Integer
    Dim intDelimit As Integer

    If intAnchor = 0 Then intAnchor = 1

    intQuote = InStr(intAnchor, strList, QUOTEMARK)
    intDelimit = InStr(intAnchor, strList, strDelimit)
    
    If intQuote > 0 Then
        If intQuote < intDelimit Then
            '
            ' A quote appeared before the next delimiter.  This
            ' means we might be inside quotes.  We still need to check
            ' if the closing quote comes after the delmiter or not.
            '
            intAnchor = intQuote + 1
            intQuote = InStr(intAnchor, strList, QUOTEMARK)
            If intQuote > intDelimit Then
                '
                ' The delimiter was inside quotes.  Therefore, ignore it.
                ' The next delimiter after the closing quote must be outside
                ' of quotes or else we have a corrupt file.
                '
                intAnchor = intQuote + 1
                intDelimit = InStr(intAnchor, strList, strDelimit)
                '
                ' Sanity check.  Make sure there is not another quote before
                ' the delimiter we just found.
                '
                If intDelimit > 0 Then
                    intQuote = InStr(intAnchor, strList, QUOTEMARK)
                    If intQuote > 0 Then
                        If intQuote < intDelimit Then
                            '
                            ' Something is wrong.  We've encountered a stray
                            ' quote.  Means the string is probably corrupt.
                            '
                            intDelimit = -1 ' Error
                        End If
                    End If
                End If
            End If
        End If
    End If
    intGetNextFldOffset = intDelimit
End Function
'-----------------------------------------------------------
' FUNCTION: SourceFileIsNewer
'
' Determines whether a file to be installed is newer than an
' existing file already on the system.
'
' IN: [sFile] - structure containing information about the source file
'     [strSrcName] - name of source file
'     [strSrcDir] - location of source file
'     [strDestName] - name of destination file
'     [strDestDir] - destination directory for file
' OUT: [strDestVer] - a string representing the version of the destination file
'
' Returns: True if there is no existing (destination) file.
'          True if the destination file does exist and the
'          source file has a newer version.
'          True if the destination file does exist but one
'          or both files does not have version information
'          and the source file has a newer timestamp.
'          False otherwise
'-----------------------------------------------------------

Private Function SourceFileIsNewer(sFile As FILEINFO, strSrcName As String, strSrcDir As String, strDestName As String, strDestDir As String, ByRef strDestVer As String) As Boolean
    Dim fSrcVer As Boolean
    Dim sSrcVerInfo As VERINFO
    Dim fRemoteReg As Boolean
    Dim sDestVerInfo As VERINFO
    Dim datDest As Date
    '
    'The stuff below tries to save some time by pre-checking whether a file
    'should be installed before VerInstallFile does its thing.
    'Basically, if both files have version numbers, they are compared.
    'Otherwise, we compare date.
    '
    On Error Resume Next
    strDestVer = vbNullString
    '
    'Always attempt to get the source file version number.  If the setup
    'info file did not contain a version number (sSrcVerInfo.nMSHi =
    'gintNOVERINFO), we attempt to read the version number from the source
    'file.
    '
    fSrcVer = True
    sSrcVerInfo = sFile.sVerInfo
    If sSrcVerInfo.FileVerPart1 = GintNOVERINFO Then
        fSrcVer = GetFileVerStruct(strSrcDir & strSrcName, sSrcVerInfo)
    End If
    '
    'If there is an existing destination file with version information, then
    'compare its version number to the source file version number.
    '
    If fSrcVer Then
        fRemoteReg = (UCase$(sFile.strRegister) = MstrREMOTEREGISTER) 'mstrREMOTEREGISTER is uppercase
        If GetFileVerStruct(strDestDir & strDestName, sDestVerInfo) Then
            With sDestVerInfo
                strDestVer = CStr(.FileVerPart1) & "." & _
                             CStr(.FileVerPart2) & "." & _
                             CStr(.FileVerPart3) & "." & _
                             CStr(.FileVerPart4)
            End With
            'Both source and destinations have versions. Compare them.
            SourceFileIsNewer = IsNewerVer(sSrcVerInfo, sDestVerInfo)
            Err.Clear
            Exit Function
        End If
    End If
    '
    'Since neither file has a version, the best we can do is compare dates.
    '------------------FIX?------------------------------------
    Err.Clear
    datDest = FileDateTime(strDestDir & strDestName)
    If Err.Number = 0 Then
        If sFile.varDate > datDest Then  '--changed < to > (see below)
            SourceFileIsNewer = True
        Else
            SourceFileIsNewer = False
        End If
    Else
        'Evidently the destination file does not exist. Therefore the source
        '   file should be copied and can be considered newer.
        SourceFileIsNewer = True
    End If
    Err.Clear
    
    '---------change: < to > above. this sub checks whether source (installing)
    '-- file is newer than current file on machine.
    '-- if it can't find versions it compares dates,
    '-- but the date check was backwards.
End Function

Private Function IsNewerVer(sSrcVer As VERINFO, sDestVer As VERINFO) As Boolean
    'For the top three version fields, if the source is greater, immediately
    '   return True. If the destination is greater, immediately return False.
    '   If they are equal, fall through to check the next field. For the last
    '   version field, if the source is greater, immediately return True.
    '   Otherwise, either the destination is newer or the files are the same.
    '   Either way, immediately return False.
    IsNewerVer = False
    With sSrcVer
        If .FileVerPart1 > sDestVer.FileVerPart1 Then GoTo INVNewer
        If .FileVerPart1 < sDestVer.FileVerPart1 Then Exit Function

        If .FileVerPart2 > sDestVer.FileVerPart2 Then GoTo INVNewer
        If .FileVerPart2 < sDestVer.FileVerPart2 Then Exit Function

        If .FileVerPart3 > sDestVer.FileVerPart3 Then GoTo INVNewer
        If .FileVerPart3 < sDestVer.FileVerPart3 Then Exit Function

        If .FileVerPart4 > sDestVer.FileVerPart4 Then GoTo INVNewer
        If .FileVerPart4 = sDestVer.FileVerPart4 Then IsNewerVer = False
    End With
'Either the files are the same or the destination's 4th field is greater. Either
'   way, return False.
Exit Function
INVNewer:
    IsNewerVer = True
End Function
Public Sub MakePath(ByVal sPath As String, IfLog As Boolean)
 '--create a folder path for setup. If fail then setup must quit.
  Dim s2 As String
  Dim Pt1 As Long, Pt2 As Long
      On Error Resume Next
        
      AddSlash sPath
      Pt1 = (InStr(1, sPath, BACK_SLASH) + 1)
    Do
       Pt2 = InStr(Pt1, sPath, BACK_SLASH)
           If (Pt2 = 0) Then Exit Do
       s2 = Left$(sPath, (Pt2 - 1))
         If Not DirExists(s2) Then
              If (IfLog = True) Then
                 NewAction GstrKEY_CREATEDIR, QUOTEMARK & s2 & QUOTEMARK
              End If
            Err.Clear
            MkDir s2
              If (Err.Number <> 0) Then
                   If (IfLog = True) Then
                      LogError "Could not create folder " & s2
                      AbortAction
                   End If
                     GoTo Done
              Else
                  If (IfLog = True) Then
                     CommitAction
                  End If
              End If
          End If
      Pt1 = (Pt2 + 1)
      If (Pt1 >= Len(sPath)) Then Exit Do
    Loop
       
    Err.Clear
    Exit Sub
Done:
    Err.Clear
    MsgBox "Setup cannot continue. Unable to create folder" & vbCrLf & s2, 64, sSETUP
    ExitSetup GintRET_ABORT
End Sub

Public Sub DecideIncrementRefCount(ByVal strFullPath As String, ByVal fShared As Boolean, ByVal fSystem As Boolean, ByVal fFileAlreadyExisted As Boolean)
    'Reference counting takes place under both Windows 95 and Windows NT
    If fShared Or fSystem Then
        IncrementRefCount strFullPath, fFileAlreadyExisted
    End If
End Sub

Public Sub IncrementRefCount(ByVal strFullPath As String, ByVal fFileAlreadyExisted As Boolean)
    Dim strSharedDLLsKey As String
    Dim fSuccess As Boolean
    Dim hKey As Long
    Dim lCurRefCount As Long

    strSharedDLLsKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\SharedDLLs"
    
    'We must always use the LFN for the filename, so that we can uniquely
    'and accurately identify the file in the registry.
    strFullPath = GetLongPath(strFullPath)
    
    'Get the current reference count for this file

    fSuccess = SetupRegCreateKey(HKEY_LOCAL_MACHINE, strSharedDLLsKey, vbNullString, hKey)
    If fSuccess Then
        If Not RegQueryRefCount(hKey, strFullPath, lCurRefCount) Then
            'No current reference count for this file
            If fFileAlreadyExisted Then
                'If there was no reference count, but the file was found
                'on the hard drive, it means one of two things:
                '  1) This file is shipped with the operating system
                '  2) This file was installed by an older setup program
                '     that does not do reference counting
                'In either case, the correct conservative thing to do
                'is assume that the file is needed by some application,
                'which means it should have a reference count of at
                'least 1.  This way, our application removal program
                'will not delete this file.
                lCurRefCount = 1

            Else
                lCurRefCount = 0
            End If
        End If
        
        'Increment the count in the registry
        fSuccess = RegSetNumericValue(hKey, strFullPath, lCurRefCount + 1, False)
        If Not fSuccess Then
            GoTo DoErr
        End If
        RegCloseKey hKey
    Else
        GoTo DoErr
    End If
    
DoErr:
   Exit Sub
End Sub

Private Function RegQueryRefCount(ByVal hKey As Long, ByVal strValueName As String, lRefCount As Long) As Boolean
    Dim lResult As Long
    Dim lValueType As Long
    Dim lBuf As Long
    Dim lDataBufSize As Long
    Dim strRefCount As String

    ' Get length/data type
    lDataBufSize = 4

    lResult = RegQueryValueExAny(hKey, strValueName, 0&, lValueType, lBuf, lDataBufSize)
    If lResult = ERROR_SUCCESS Then
        Select Case lValueType
            Case REG_DWORD
                lRefCount = lBuf
                RegQueryRefCount = True
            Case REG_BINARY
                If lDataBufSize = 4 Then
                    lRefCount = lBuf
                    RegQueryRefCount = True
                End If
            Case REG_SZ
                 If RegQueryStringValue(hKey, strValueName, strRefCount) Then
                    lRefCount = Val(strRefCount)
                    RegQueryRefCount = True
                End If
        End Select
    End If
End Function

Public Function fWithinAction() As Boolean
    fWithinAction = (fDllWithinAction() <> 0)
End Function

Public Sub MoveAppRemovalFiles()
    Dim strNewAppRemovalLogName As String
    Dim iExt As Integer

     jsDeleteFile sCABPath
        '-- strange problem: Even though setup.exe is no longer used,
        '-- a copy of the CAB ends up in Windows folder. It appears
        '-- that VB6STKIT.DLL's file extraction function is actually moving
        '-- the CAB to windows folder as a hardcoded operation!
        '-- Maybe the extraction function needs the CAB in the same folder? Odd.
        '-- In any case, when finished delete any program CAB in Windows folder.
      If (FileExists(sWinFol & sCABFileName) = True) Then
         jsDeleteFile sWinFol & sCABFileName
      End If
    KillTempFolder
   
    strNewAppRemovalLogName = sAppFolder & "ST6UNST.LOG"
  If FileExists(strNewAppRemovalLogName) Then
        '..find another name if file exists:
    Do
        If iExt > 999 Then
           GoTo CopyErr
        End If
      strNewAppRemovalLogName = sAppFolder & "ST6UNST." & Format$(iExt, "000")
            If Not FileExists(strNewAppRemovalLogName) Then
                Exit Do 'Unique name was found
            Else
                iExt = iExt + 1
            End If
        Loop
  End If

    On Error GoTo CopyErr
    FileCopy sAppRemovalLog, strNewAppRemovalLogName
    
    'Now we need to start logging in the new logfile, so that the
    'creation of the application removal icon under NT gets logged.
    EnableLogging strNewAppRemovalLogName

    On Error GoTo 0
    If Not RegisterAppRemovalEXE(sAppRemovalEXE, strNewAppRemovalLogName) Then
      MsgBox "Error registering the application removal executable with Windows.", 64, sSETUP
      ExitSetup GintRET_FATAL
    End If
    
    'Now we can delete the original logfile.
    On Error Resume Next
    Kill sAppRemovalLog
    sAppRemovalLog = strNewAppRemovalLogName
    GfAppRemovalFilesMoved = True
    
    Exit Sub
    
CleanUpOnErr:
    On Error Resume Next
    Kill strNewAppRemovalLogName
    On Error GoTo 0
    MsgBox "Error copying program uninstall log.", 64, sSETUP
    ExitSetup GintRET_FATAL
    
CopyErr:
    Resume CleanUpOnErr
End Sub

Private Sub KillTempFolder()
    Const sWILD As String = "*.*"
    Dim sFile As String
    
    On Error Resume Next
    
    sFile = Dir$(sTempInstallFol & sWILD, vbHidden Or vbReadOnly Or vbSystem)
    Do While Len(sFile) > 0
        SetAttr sTempInstallFol & sFile, vbNormal
        Kill sTempInstallFol & sFile
        sFile = Dir$
    Loop
    RmDir sTempInstallFol
End Sub
