Attribute VB_Name = "ModLog"
Option Explicit

'vb6stkit.dll logging errors
Public Const LOGERR_SUCCESS = 0
Public Const LOGERR_INVALIDARGS = 1
Public Const LOGERR_OUTOFMEMORY = 2
Public Const LOGERR_EXCEEDEDCAPACITY = 3
Public Const LOGERR_WRITEERROR = 4
Public Const LOGERR_NOCURRENTACTION = 5
Public Const LOGERR_UNEXPECTED = 6
Public Const LOGERR_FILENOTFOUND = 7

'Logging error Severities
Public Const LogErrOK = 1 ' OK to continue upon this error
Public Const LogErrFatal = 2 ' Must terminate install upon this error

Public Sub ShowLoggingError(ByVal lErr As Long, ByVal lErrSeverity As Long)
    Dim strErrMsg As String
    Static fRecursive As Boolean
    Dim sErr As String
    Dim iRet As Integer
    Dim fAbort As Boolean
  
    If lErr = LOGERR_SUCCESS Then
        Exit Sub
    End If
    
    sErr = "An error has occurred. Setup cannot continue."
    If fRecursive Then
        'If we're getting called recursively, we're likely
        'getting errors while trying to write out errors to
        'the logfile.  Nothing to do but turn off logging
        'and abort setup.
        DllDisableLogging  'DisableLogging
        MsgBox sErr, 64, sSETUP
        ExitSetup GintRET_FATAL
    End If

    fRecursive = True
        MsgBox sErr, 64, sSETUP
        ExitSetup GintRET_ABORT

    fRecursive = False
End Sub

Public Sub NewAction(ByVal strKey As String, ByVal strData As String)
    ShowLoggingError DllNewAction(strKey, strData), LogErrFatal
End Sub

Public Sub CommitAction()
    ShowLoggingError DllCommitAction(), LogErrFatal
End Sub

Public Sub AbortAction()
    ShowLoggingError DllAbortAction(), LogErrFatal
End Sub

Public Sub LogError(ByVal strErr As String)
    ShowLoggingError DllLogError("Error:", "During action:", strErr), LogErrFatal
End Sub

Public Sub LogNote(ByVal strNote As String)
    ShowLoggingError DllLogNote(strNote), LogErrOK
End Sub

Public Sub AddActionNote(ByVal strNote As String)
    ShowLoggingError DllAddActionNote(strNote), LogErrOK
End Sub

Public Sub EnableLogging(ByVal strLogFileName As String)
    ShowLoggingError DllEnableLogging(strLogFileName), LogErrFatal
End Sub
