Attribute VB_Name = "ModRegister"
Option Explicit

' Loop through the list (array) of files to register that
' was created in the CopySection function and register
' each file therein as required
'
' Notes: msRegInfo() array created by CopySection function
'-----------------------------------------------------------
'
Public Sub RegisterFiles()
    'This should remain uppercase.
    Const strEXT_EXE$ = "EXE"

    Dim intIdx As Integer, iRet As Integer
    Dim intLastIdx As Integer
    Dim strFilename As String
    Dim strMsg As String

    Dim intDllSelfRegRet As Integer
    Dim intErrRes As Integer
    Const FAIL_OLE = 2
    Const FAIL_LOAD = 3
    Const FAIL_ENTRY = 4
    Const FAIL_REG = 5
      On Error Resume Next
       'Get number of items to register, if none then we can get out of here
    
    intLastIdx = UBound(msRegInfo)
    If Err.Number <> 0 Then
        GoTo RFCleanup
    End If

   For intIdx = 0 To intLastIdx
        strFilename = msRegInfo(intIdx).strFilename
       If GetFileExtension(msRegInfo(intIdx).strRegister) = UCase$(GsEXT_REG) Then
         If UCase$(BaseName(msRegInfo(intIdx).strFilename)) = UCase$(BaseName(msRegInfo(intIdx).strRegister)) Then
            Kill msRegInfo(intIdx).strRegister
         End If
            GoTo GoodToGo
       End If
     Select Case UCase$(msRegInfo(intIdx).strRegister)
            Case MstrDLLSELFREGISTER
                NewAction GstrKEY_DLLSELFREGISTER, QUOTEMARK & strFilename & QUOTEMARK
                
RetryDllSelfReg:
                Err.Clear
                intErrRes = 0
                intDllSelfRegRet = DLLSelfRegister(strFilename)
                If (Err.Number <> 0) And (Err.Number <> 49) Then
                  intErrRes = 1
                Else
                   If intDllSelfRegRet <> 0 Then intErrRes = 1
                End If
                        
                If intErrRes = 1 Then
                    'There was some kind of error. log it.
                    LogError "Failure attempting to register file: " & strFilename
                   
AskWhatToDo:
                    strMsg = "Failure attempting to register file:" & vbCrLf & strFilename
                    iRet = MsgBox(strMsg, vbAbortRetryIgnore, sSETUP)
         
                    Select Case iRet
                        Case vbAbort:
                            ExitSetup GintRET_ABORT
                            GoTo AskWhatToDo
                        Case vbRetry:
                            GoTo RetryDllSelfReg
                        Case vbIgnore:
                            AbortAction
                    End Select
                  Else
                    CommitAction
                  End If
                
                
            Case MstrEXESELFREGISTER
                '
                'Only self register EXE files
                
                If GetFileExtension(strFilename) = strEXT_EXE Then 'strEXT_EXE is uppercase.
                    NewAction GstrKEY_EXESELFREGISTER, QUOTEMARK & strFilename & QUOTEMARK
                    Err.Clear
                    ExeSelfRegister strFilename
                    If Err.Number <> 0 Then
                        AbortAction
                    Else
                        CommitAction
                    End If
                End If
           
            Case MstrTLBREGISTER
                NewAction GstrKEY_TLBREGISTER, QUOTEMARK & strFilename & QUOTEMARK
                '
                ' Call vb6stkit.dll's RegisterTLB export which calls
                ' LoadTypeLib and RegisterTypeLib.
                '
RetryTLBReg:
                If Not RegisterTLB(strFilename) Then
                    ' Registration of the TLB file failed.
                    LogError "Failure attempting to register type library: " & strFilename
TLBAskWhatToDo:
                    strMsg = "Failure attempting to register type library:" & vbCrLf & strFilename
                    iRet = MsgBox(strMsg, vbAbortRetryIgnore, sSETUP)
                    Select Case iRet
                        Case vbAbort:
                            ExitSetup GintRET_ABORT
                            GoTo TLBAskWhatToDo
                        Case vbRetry:
                            GoTo RetryTLBReg
                        Case vbIgnore:
                            AbortAction
                    End Select
                Else
                    CommitAction
                End If
            Case MstrVBLREGISTER
                '
                ' RegisterVBLFile takes care of logging, etc.
                RegisterVBLFile strFilename
            Case Else
                RegEdit msRegInfo(intIdx).strRegister
        End Select
GoodToGo:
    Next
      Erase msRegInfo
RFCleanup:
    Err.Clear
End Sub

Private Sub RegEdit(ByVal strRegFile As String)
  Const strREGEDIT$ = "REGEDIT /S "
  Dim fShellOK As Integer
  Dim sMes As String
   On Error Resume Next

    If FileExists(strRegFile) Then
        strRegFile = AddQuotesToFN(strRegFile)
        fShellOK = SyncShell(strREGEDIT & strRegFile, INFINITE, , True)
       
    Else
       sMes = "File not found:" & vbCrLf & strRegFile & vbCrLf & "Setup cannot continue."
       MsgBox sMes, 64, sSETUP
        ExitSetup GintRET_FATAL
    End If

    Err.Clear
End Sub
'-----------------------------------------------------------
' SUB: RegisterLicenses
'
' Find all the setup.lst license entries and register
' them.
'-----------------------------------------------------------
'
Public Sub RegisterLicenses()
    Const strINI_LICENSES = "Licenses"
    Const strREG_LICENSES = "Licenses"
    Dim iLic As Integer
    Dim strLine As String
    Dim strLicKey As String
    Dim strLicVal As String
    Dim iCommaPos As Integer
    Dim strMsg As String
    Dim hkeyLicenses As Long
    Const strCopyright$ = "Licensing: Copying the keys may be a violation of established copyrights."

    'Make sure the Licenses key exists
    If Not SetupRegCreateKey(HKEY_CLASSES_ROOT, strREG_LICENSES, vbNullString, hkeyLicenses) Then
        'RegCreateKey will have already displayed an error message
        '  if something's wrong
        ExitSetup GintRET_FATAL
    End If
    If Not RegSetStringValue(hkeyLicenses, vbNullString, strCopyright, False) Then
        RegCloseKey hkeyLicenses
        ExitSetup GintRET_FATAL
    End If
    RegCloseKey hkeyLicenses
    
    iLic = 1
    Do
        strLine = ReadIniFile(sLSTFile, strINI_LICENSES, "License" & iLic)
        If Len(strLine) = 0 Then
            '
            ' We've got all the licenses.
            '
            Exit Sub
        End If
        strLine = UnQuoteString(strLine)
        '
        ' We have a license, parse it and register it.
        '
        iCommaPos = InStr(strLine, sCOMMA)
        If iCommaPos = 0 Then
            '
            ' Looks like the setup.lst file is corrupt.  There should
            ' always be a comma in the license information that separates
            ' the license key from the license value.
            '
            GoTo RLError
        End If
        strLicKey = Left$(strLine, iCommaPos - 1)
        strLicVal = Mid$(strLine, iCommaPos + 1)
        
        RegisterLicense strLicKey, strLicVal
        
        iLic = iLic + 1
    Loop While Len(strLine) > 0
    Exit Sub
        
RLError:
    strMsg = "Error in setup file license section. Line:" & vbCrLf & strLine & vbCrLf & "Setup cannot continue."
    MsgBox strMsg, 64, sSETUP
    ExitSetup GintRET_FATAL
End Sub
'-----------------------------------------------------------
' SUB: RegisterLicense
'
' Register license information given the key and default
' value.  License information always goes into
' HKEY_CLASSES_ROOT\Licenses.
'-----------------------------------------------------------
'
Private Sub RegisterLicense(strLicKey As String, strLicVal As String)
    Const strREG_LICENSES = "Licenses"
    Dim hKey As Long
    '
    ' Create the key
    '
    If Not SetupRegCreateKey(HKEY_CLASSES_ROOT, strREG_LICENSES, strLicKey, hKey) Then
        '
        ' RegCreateKey displays an error if something goes wrong.
        '
        GoTo REGError
    End If
    '
    ' Set the key's value
    '
    If Not RegSetStringValue(hKey, vbNullString, strLicVal, True) Then
        '
        ' RegSetStringValue displays an error if something goes wrong.
        '
        GoTo REGError
    End If
    '
    ' Close the key
    '
    RegCloseKey hKey

    Exit Sub
        
REGError:
    '
    ' Error messages should have already been displayed.
    '
    ExitSetup GintRET_FATAL
End Sub
'-----------------------------------------------------------
' SUB: RegisterVBLFile
'
' Register license information in a VB License (vbl) file.
' Basically, parse out the license info and then call
' RegisterLicense.
'
' If strVBLFile is not a valid VBL file, nothing is
' registered.
'-----------------------------------------------------------
'
Private Sub RegisterVBLFile(strVBLFile As String)
    Dim strLicKey As String
    Dim strLicVal As String
    
    GetLicInfoFromVBL strVBLFile, strLicKey, strLicVal
    If Len(strLicKey) > 0 Then
        RegisterLicense strLicKey, strLicVal
    End If
End Sub

Public Sub GetLicInfoFromVBL(strVBLFile As String, strLicKey As String, strLicVal As String)
    Const strLICKEYBASE = "HKEY_CLASSES_ROOT\Licenses\"
    Dim fn As Integer
    Dim strTemp As String
    Dim posEqual As Integer
    Dim fLicFound As Boolean
    
    fn = FreeFile
    Open strVBLFile For Input Access Read Lock Read Write As #fn
    '
    ' Read through the file until we find a line that starts with strLICKEYBASE
    '
    Do Until EOF(fn)
        Line Input #fn, strTemp
        strTemp = Trim$(strTemp)
        ' Avoid Option Compare Text and use explicit UCase comparisons because there
        ' is a Unicode character (&H818F) which is equal to a path separator when
        ' using Option Compare Text.
        If InStr(1, UCase$(strTemp), UCase$(strLICKEYBASE)) = 1 Then
            '
            ' We've got the line we want.
            '
            fLicFound = True
            Exit Do
        End If
    Loop

    Close fn

    If fLicFound Then
        '
        ' Parse the data on this line to split out the
        ' key and the license info.  The line should be
        ' the form of:
        ' "HKEY_CLASSES_ROOT\Licenses\<lickey> = <licval>"
        '
        ' First, get rid of the HKEY_CLASSES_ROOT\Licenses\ part.
        strTemp = Mid$(strTemp, Len(strLICKEYBASE) + 1)
        
        posEqual = InStr(strTemp, GstrASSIGN)
        If posEqual > 0 Then
            strLicKey = Trim$(Left$(strTemp, posEqual - 1))
            strLicVal = Trim$(Mid$(strTemp, posEqual + 1))
        End If
    Else
        strLicKey = vbNullString
        strLicVal = vbNullString
    End If
End Sub

Public Function RegisterAppRemovalEXE(ByVal strAppRemovalEXE As String, ByVal strAppRemovalLog As String) As Boolean
      On Error GoTo Err
    Const strREGSTR_VAL_AppRemoval_APPNAMELINE = "ApplicationName"
    Const strREGSTR_VAL_AppRemoval_DISPLAYNAME = "DisplayName"
    Const strREGSTR_VAL_AppRemoval_COMMANDLINE = "UninstallString"
    Const strREGSTR_VAL_AppRemoval_APPTOUNINSTALL = "AppToUninstall"
       '-- new for uninstall key:
    Const cAPPSIZE_VAL As String = "EstimatedSize"  '-- installed software total size (KB) for XP add/remove window.
    Const cAPPICON_VAL As String = "DisplayIcon"  '-- program icon to show in XP add/remove window. (File must be in app. folder.)
      '--------------------------

    Dim strREGSTR_PATH_UNINSTALL As String
    Dim strAppRemovalCmdLine As String
    Dim strMsg As String
    Dim iAppend As Integer
    Dim fOk As Boolean
    Dim hkeyAppRemoval As Long
    Dim hkeyOurs As Long
    Dim i As Integer
    Dim strAppRemovalKey As String
    Dim strAppRemovalKeyBase As String
    Dim hkeyTest As Long
    Dim strDisplayName As String
    Dim strDisplayNameBase As String
    Dim LRet As Long

    strREGSTR_PATH_UNINSTALL = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
    
    'The command-line for the application removal executable is simply the path
    'for the installation logfile
    strAppRemovalCmdLine = GetAppRemovalCmdLine(strAppRemovalEXE, strAppRemovalLog, APPREMERR_NONE, False)
    '
    ' Make sure that the Removal command line (including path, filename, commandline args, etc.
    ' is not longer than the max allowed, which is _MAX_PATH.
    '
    If Len(strAppRemovalCmdLine) >= MAX_PATH Then
        strMsg = "Setup cannot continue. Path of program removal file is too long."
        strMsg = strMsg & "Setup must be re-run using a different folder."
        MsgBox strMsg, 64, sSETUP
        ExitSetup GintRET_FATAL
    End If
    '
    ' Create registry entries to tell Windows where the app removal executable is,
    ' how it should be displayed to the user, and what the command-line arguments are
  
    'Go ahead and create a key to the main Uninstall branch
    If Not SetupRegCreateKey(HKEY_LOCAL_MACHINE, strREGSTR_PATH_UNINSTALL, vbNullString, hkeyAppRemoval) Then
        GoTo Err
    End If
    
    'We need a unique key.  This key is never shown to the end user.  We will use a key of
    'the form 'ST5UNST #xxx'
    strAppRemovalKeyBase = "ST6UNST #"
    iAppend = 1
    
    Do
        strAppRemovalKey = strAppRemovalKeyBase & Format$(iAppend)
        If SetupRegOpenKey(hkeyAppRemoval, strAppRemovalKey, hkeyTest) Then
            'This key already exists.  But we need a unique key.
            RegCloseKey hkeyTest
        Else
            'We've found a key that doesn't already exist.  Use it.
            Exit Do
        End If
        
        iAppend = iAppend + 1
    Loop
    
    '
    ' We also need a unique displayname.  This name is
    ' the only means the user has to identify the application
    ' to remove
    '
    strDisplayName = sAppName 'First try... Application name
    If Not IsDisplayNameUnique(hkeyAppRemoval, strDisplayName) Then
        'Second try... Add path
        strDisplayName = strDisplayName & " (" & sAppFolder & ")"
        If Not IsDisplayNameUnique(hkeyAppRemoval, strDisplayName) Then
            'Subsequent tries... Append a unique integer
            strDisplayNameBase = strDisplayName
            iAppend = 3
            Do
                strDisplayName = strDisplayNameBase & " #" & Format$(iAppend)
                If IsDisplayNameUnique(hkeyAppRemoval, strDisplayName) Then
                    Exit Do
                Else
                    iAppend = iAppend + 1
                End If
            Loop
        End If
    End If
    
    'Go ahead and fill in entries for the app removal executable
    If Not SetupRegCreateKey(hkeyAppRemoval, strAppRemovalKey, vbNullString, hkeyOurs) Then
        GoTo Err
    End If
    If Not RegSetStringValue(hkeyOurs, strREGSTR_VAL_AppRemoval_APPNAMELINE, sAppEXEName, False) Then
        GoTo Err
    End If
    If Not RegSetStringValue(hkeyOurs, strREGSTR_VAL_AppRemoval_DISPLAYNAME, strDisplayName, False) Then
        GoTo Err
    End If
    If Not RegSetStringValue(hkeyOurs, strREGSTR_VAL_AppRemoval_COMMANDLINE, strAppRemovalCmdLine, False) Then
        GoTo Err
    End If
    
    If Not RegSetStringValue(hkeyOurs, strREGSTR_VAL_AppRemoval_APPTOUNINSTALL, sAppEXEName, False) Then
        GoTo Err
    End If
    
 
 '-- New settings in Uninstall key.
 '-- Don't go to error on fail because these settings are optional. --
      Dim Boo1 As Boolean
        '-- add/remove icon:
         If (Len(sRemIcon) > 0) Then
           '-- sAppFolder ("C:\program files\some program\") & sRemIcon ("someprog.exe 0")
            sRemIcon = sAppFolder & sRemIcon
            Boo1 = RegSetStringValue(hkeyOurs, cAPPICON_VAL, sRemIcon, False)
         End If
        '-- app size value:
         If (LRemAppSize > 0) Then
            Boo1 = RegSetNumericValue(hkeyOurs, cAPPSIZE_VAL, LRemAppSize, False)
         End If
     
    RegCloseKey hkeyAppRemoval
    RegCloseKey hkeyOurs
    
    RegisterAppRemovalEXE = True
    Exit Function
    
Err:
    If hkeyOurs Then
        RegCloseKey hkeyOurs
        LRet = RegDeleteKey(hkeyAppRemoval, strAppRemovalKey)
    End If
    If hkeyAppRemoval Then
        RegCloseKey hkeyAppRemoval
    End If
End Function

Private Sub ExeSelfRegister(ByVal strFilename As String)
    Const strREGSWITCH$ = " /REGSERVER"
    'Synchronously shell out and run the .EXE with the self registration switch
    SyncShell AddQuotesToFN(strFilename) & strREGSWITCH, INFINITE, , True
End Sub
