Attribute VB_Name = "modShell"
Option Explicit
'--this module has functions for making shortcuts and for getting folder paths.
Public Const S_OK = 0

Public Const CSIDL_APPDATA = &H1A    '-- application data.
Public Const CSIDL_COMMON_APPDATA = &H23   '-- ..\All Users\Application Data
Public Const CSIDL_DESKTOP = &H0
Public Const CSIDL_COMMON_DESKTOPDIRECTORY = &H19  '-- NT - all users desktop.
Public Const CSIDL_FONTS = &H14   '-- Fonts
Public Const CSIDL_PROGRAMS = &H2  '-- user's start menu\programs.
Public Const CSIDL_COMMON_PROGRAMS = &H17  '-- NT - All Users\Start Menu\Programs
    'Public Const CSIDL_FLAG_CREATE = &H8000&
    'Private Const SHGFP_TYPE_CURRENT = 0
    'Private Const SHGFP_TYPE_DEFAULT = 1

Public Declare Function SHGetSpecialFolderLocation Lib "shell32" (ByVal hwndOwner As Long, ByVal nFolder As Long, ByRef pidl As Long) As Long
Public Declare Function SHGetPathFromIDListA Lib "shell32" (ByVal pidl As Long, ByVal pszPath As String) As Long
Public Declare Function SHGetDesktopFolder Lib "shell32" (ByRef pshf As IVBShellFolder) As Long
Public Declare Function SHGetMalloc Lib "shell32" (ByRef pMalloc As IVBMalloc) As Long
Public Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)

'-- get system folder paths from special folder ID: '-- GetFolPath(constant)
Public Function GetFolPath(LID As Long) As String
  Dim sPath As String
  Dim pidl As Long
    On Error Resume Next
        GetFolPath = ""
      If (SHGetSpecialFolderLocation(0, LID, pidl) = S_OK) Then
        '--(owner window, csidl constant, pointer)
        sPath = String$(MAX_PATH, 0)
         If SHGetPathFromIDListA(ByVal pidl, ByVal sPath) Then
             GetFolPath = Left$(sPath, InStr(1, sPath, Chr$(0)) - 1)
         End If
           'free the pidl
         CoTaskMemFree pidl
      End If
 End Function

Public Function GetLongPath(ByVal sShtPath As String) As String
    Dim oDesktop As IVBShellFolder
    Dim nEaten As Long
    Dim pidl As Long
    Dim sPath As String
    Dim oMalloc As IVBMalloc
  On Error Resume Next
     GetLongPath = sShtPath
    If (Len(sShtPath) > 0) Then
        SHGetDesktopFolder oDesktop
        oDesktop.ParseDisplayName 0, 0, sShtPath, nEaten, pidl, 0
        sPath = String$(MAX_PATH, 0)
        SHGetPathFromIDListA pidl, sPath
        SHGetMalloc oMalloc
        oMalloc.Free pidl
        GetLongPath = StringFromBuffer(sPath)
    End If
End Function

Public Sub AddShortcuts(sAppFolPath, sEXEName As String, sLNKName As String)
  '--add start menu link, desktop link, quick launch link.
  '-- program folder path, path of EXE linked, name of EXE, link name.
 Dim SLLK As cShellLink
 Dim sFolP As String, sEXEPath As String, sLinkFolPath As String, sLinkPath As String
 Dim LRet As Long
     On Error Resume Next
 
  sFolP = sAppFolPath
  AddSlash sFolP
  sEXEPath = sFolP & sEXEName '--full path to exe.
  Set SLLK = New cShellLink
  
   '-- each section below checks for a valid folder path,
   '-- then builds the LNK file path string, then checks to see
   '-- whether there's already a LNK file of that name.
   '-- Assuming no such file exists, it then calls the class
   '-- function to create a LNK file. Finally it logs the action
   '-- if successful, so that the LNK will be removed at uninstall.
   
     '-- start menu link:
  If (DirExists(sStartMenuProgFol) = True) Then
      sLinkFolPath = sStartMenuProgFol
      AddSlash sLinkFolPath
      sLinkPath = sLinkFolPath & sLNKName & ".LNK"
        If (FileExists(sLinkPath) = False) Then
          LRet = SLLK.CreateShortcut(sLinkPath, sEXEPath, sEXEName, sEXEPath, 0)
            If (LRet = 0) Then
               NewAction GstrKEY_PRIVATEFILE, QUOTEMARK & sLinkPath & QUOTEMARK
               AddActionNote "Start Menu link created."
               CommitAction
            End If
        End If
   End If
   
    '-- desktop link:
  If (DirExists(sDesktopFol) = True) And (frmBegin.CkDesk.Value = 1) Then
      sLinkFolPath = sDesktopFol
      AddSlash sLinkFolPath
      sLinkPath = sLinkFolPath & sLNKName & ".LNK"
        If (FileExists(sLinkPath) = False) Then
          LRet = SLLK.CreateShortcut(sLinkPath, sEXEPath, sEXEName, sEXEPath, 0)
            If (LRet = 0) Then
               NewAction GstrKEY_PRIVATEFILE, QUOTEMARK & sLinkPath & QUOTEMARK
               AddActionNote "Desktop link created."
               CommitAction
            End If
        End If
   End If
   
     '-- quick launch link:
  If (DirExists(sQLFol) = True) And (frmBegin.CkQ.Value = 1) Then
      sLinkFolPath = sQLFol
      AddSlash sLinkFolPath
      sLinkPath = sLinkFolPath & sLNKName & ".LNK"
        If (FileExists(sLinkPath) = False) Then
          LRet = SLLK.CreateShortcut(sLinkPath, sEXEPath, sEXEName, sEXEPath, 0)
            If (LRet = 0) Then
               NewAction GstrKEY_PRIVATEFILE, QUOTEMARK & sLinkPath & QUOTEMARK
               AddActionNote "Quick Launch link created."
               CommitAction
            End If
        End If
   End If
  
  Set SLLK = Nothing
End Sub
